#include "testlib.h"
#include <vector>
#include <algorithm>

const int maxn = 1000000;

const std::vector<int> MAXN = {6, 50, 500, 10000, maxn};

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());
    std::string s = inf.readToken();
    inf.readEoln();
    ensuref(1 <= s.size() && s.size() <= MAXN[group], format("s.length should be in [1, %d]", MAXN[group]).c_str());
    for (int i = 0; i < (int)s.size(); i++) {
      ensuref(s[i] == '0' || s[i] == '1', format("s[%d] should be either 0 or 1", i + 1).c_str());
    }
    inf.readEof();
    return 0;
}
