#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int MAXC = 1000000000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	int maxc = atoi(argv[3]);
	int maxd = atoi(argv[4]);

	vector<vector<pii>> polys;
	vector<pii> bb;

	for (int i = 0; i < n; ++i) {
		vector<pii> vecs;
		while (szof(vecs) < k - 1) {
			int x = rnd.next(-maxd, maxd);
			int y = rnd.next(-maxd, maxd);
			if (x == 0 && y == 0) {
				continue;
			}
			bool ok = true;
			for (auto v : vecs) {
				if ((ll) v.ff * y - (ll) v.ss * x == 0) {
					ll tmp = (ll) v.ff * x + (ll) v.ss * y;
					if (tmp > 0 || k == 3) {
						ok = false;
						break;
					}
				}
			}
			if (ok) {
				vecs.push_back({x, y});
			}
		}
		pii sum = {0, 0};
		for (auto v : vecs) {
			sum.ff += v.ff;
			sum.ss += v.ss;
		}
		if (sum.ff != 0 || sum.ss != 0) {
			bool fl = false;
			sum.ff *= -1;
			sum.ss *= -1;
			for (auto& v : vecs) {
				if ((ll) v.ff * sum.ss - (ll) v.ss * sum.ff == 0 && (ll) v.ff * sum.ff + (ll) v.ss * sum.ss > 0) {
					v.ff += sum.ff;
					v.ss += sum.ss;
					fl = true;
					break;
				}
			}
			if (!fl) {
				vecs.push_back({sum.ff, sum.ss});
			}
		}
		sort(vecs.begin(), vecs.end(), [&](pii a, pii b) {
			bool fl1 = a.ss > 0 || (a.ss == 0 && a.ff > 0);
			bool fl2 = b.ss > 0 || (b.ss == 0 && b.ff > 0);
			if (fl1 != fl2) {
				return fl1 < fl2;
			}
			return (ll) a.ff * b.ss - (ll) a.ss * b.ff > 0;
		});
		vecs.pop_back();
		polys.push_back({{0, 0}});
		for (auto p : vecs) {
			auto prev = polys.back().back();
			polys.back().push_back({prev.ff + p.ff, prev.ss + p.ss});
		}

		int minx = INF, maxx = -INF, miny = INF, maxy = -INF;
		for (auto p : polys.back()) {
			minx = min(minx, p.ff);
			maxx = max(maxx, p.ff);
			miny = min(miny, p.ss);
			maxy = max(maxy, p.ss);
		}
		for (auto& p : polys.back()) {
			p.ff -= minx;
			p.ss -= miny;
		}

		bb.push_back({maxx - minx, maxy - miny});
	}

	ll leftx = maxc * 2;
	ll lefty = maxc * 2;
	for (auto b : bb) {
		leftx -= b.ff;
		lefty -= b.ss;
	}

	assert(leftx >= 0 && lefty >= 0);
	cerr << leftx << " " << lefty << endl;

	cout << n << " " << 1 << " " << n << "\n";

	int cx = -maxc, cy = -maxc;
	for (int i = 0; i < n; ++i) {
		cout << szof(polys[i]) << "\n";
		for (auto p : polys[i]) {
			cout << cx + p.ff << " " << cy + p.ss << "\n";
		}
		cx += bb[i].ff + (leftx + i) / (n - 1);
		cy += bb[i].ss + (lefty + i) / (n - 1);
	}

	return 0;
}