#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n, a, b;
	cin >> n >> a >> b;
	--a; --b;
	vector<vector<pii>> polys(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int x, y;
			cin >> x >> y;
			polys[i].push_back({x, y});
		}
		rotate(polys[i].begin(), polys[i].begin() + rnd.next(0, k - 1), polys[i].end());
	}

	vector<int> order(n);
	iota(order.begin(), order.end(), 0);
	vector<int> where(n);
	for (int i = 0; i < n; ++i) {
		where[order[i]] = i;
	}

	cout << n << " " << where[a] + 1 << " " << where[b] + 1 << "\n";

	for (int i = 0; i < n; ++i) {
		auto& cur = polys[order[i]];
		cout << szof(cur) << "\n";
		for (pii p : cur) {
			cout << p.ff << " " << p.ss << "\n";
		}
	}

	return 0;
}